#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "msg.h"

static int *array;
static int length = 100000;

static void make_array()
{
  int i;

  array = (int *)malloc(length * sizeof(int));
  for (i = 0; i < length; i++) {
    array[i] = 1;
  }
  array[0] = 2; /* results: 2 300002 599996 */
  /* array[0] = 3; => results: 6 300006 600000 */
}

/*****************************************/

int main(int argc, char **argv) 
{
  struct connection_t **c;
  int t, i;
  int a[1], *accums;
  int single_len, last_t, last_len, len;

  t = (argc - 1) / 2;

  c = (struct connection_t **)malloc(t * sizeof(struct connection_t *));
  accums = (int *)malloc((t + 1) * sizeof(int));

  make_array();

  /* Connect to all servers: */
  for (i = 0; i < t; i++)
    c[i] = make_connection(argv[(i * 2) + 1], argv[(i * 2) + 2]);

  single_len = length / t;

  /* Last server gets leftovers if the array doesn't divide evenly: */
  last_t = t - 1;
  last_len = length - ((t - 1) * single_len);

  for (i = 0; i < t; i++) {
    /* Send array section to one server: */
    len = ((i == last_t) ? last_len : single_len);
    a[0] = len;
    send_message(c[i], 1, a);
    send_message(c[i], len, array + (i * single_len));
  }
  
  accums[0] = 0;
  for (i = 0; i < t; i++) {
    /* Get total of converted from one server: */
    recv_message(c[i], 1, accums + i + 1);
    /* Add in total from previous servers: */
    accums[i + 1] += accums[i];
  }

  for (i = 0; i < t; i++) {
    /* send preceding total back to server: */
    send_message(c[i], 1, accums + i);
  }

  for (i = 0; i < t; i++) {
    /* Receive deconvert arrays: */
    len = ((i == last_t) ? last_len : single_len);
    recv_message(c[i], len, array + (i * single_len));
    close_connection(c[i]);
  }

  printf("%d %d %d\n", array[0], array[length / 2], array[length - 1]);

  return 0;
}
