#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "msg.h"

static int *array;
static int length;

static int convert(int v)
{
  int i;

  /* Arbitrary time-consuming calculation: */
  for (i = 0; i < 1000; i++) {
    v = ((v * v) + v) % 10;
  }

  return v;
}

static int deconvert(int v)
{
  return convert(v);
}

/*****************************************/

static int convert_section(int start, int end)
{
  int i, v, accum = 0;

  for (i = start; i < end; i++) {
    v = convert(array[i]);
    accum += v;
    array[i] = v;
  }

  return accum;
}

static int do_converted_section(int start, int end, int accum)
{
  int i;

  for (i = start; i < end; i++) {
    accum += array[i];
    array[i] = deconvert(accum);
  }

  return accum;
}

/*****************************************/

int main(int argc, char **argv) 
{
  struct connection_t *c;
  int a[1];

  c = wait_for_connection(argv[1]);

  /* Get length of array section: */
  recv_message(c, 1, a);
  
  length = a[0];
  array = (int *)malloc(length * sizeof(int));

  /* Get array section: */
  recv_message(c, length, array);

  /* Convert and sum: */
  a[0] = convert_section(0, length);

  send_message(c, 1, a); /* send sum back to client */
  recv_message(c, 1, a); /* receive sum from prceding sections */

  /* Add preceding total and deconvert: */
  do_converted_section(0, length, a[0]);

  /* Send deconverted section back to server: */
  send_message(c, length, array);

  close_connection(c);

  return 0;
}
